<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="证书中文名称" prop="nameCn">
        <el-input v-model="formData.nameCn" placeholder="请输入证书中文名称" />
      </el-form-item>
      <el-form-item label="证书英文名称" prop="nameEn">
        <el-input v-model="formData.nameEn" placeholder="请输入证书英文名称" />
      </el-form-item>
      <el-form-item label="上级id" prop="parentId">
        <el-input v-model="formData.parentId" placeholder="请输入上级id" />
      </el-form-item>
      <el-form-item label="层级" prop="level">
        <el-radio-group v-model="formData.level">
          <el-radio label="1">请选择字典生成</el-radio>
        </el-radio-group>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { CertificateApi, CertificateVO } from '@/api/menduner/system/certificate'

/** 证书 表单 */
defineOptions({ name: 'CertificateForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  nameCn: undefined,
  nameEn: undefined,
  parentId: undefined,
  level: undefined
})
const formRules = reactive({
  nameCn: [{ required: true, message: '证书中文名称不能为空', trigger: 'blur' }],
  parentId: [{ required: true, message: '上级id不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await CertificateApi.getCertificate(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as CertificateVO
    if (formType.value === 'create') {
      await CertificateApi.createCertificate(data)
      message.success(t('common.createSuccess'))
    } else {
      await CertificateApi.updateCertificate(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    nameCn: undefined,
    nameEn: undefined,
    parentId: undefined,
    level: undefined
  }
  formRef.value?.resetFields()
}
</script>